{Bearbeitungsstand: 10.01.90

SIMULATIONEN - einheitliche Mengestaltung und Bedienerfhrung
               fr alle Gertesimulationen }

program SIMULAV1;

uses dos,crt,printer,windows,menue,cursor,maske,help,ted,readext, readchr;

Type
  string15=string[15];
  Dtname=string[60];
  Verfahren=string[22];
  VerfFeld=array[1..10] of Verfahren;
  datind=(vf,sl,pr,gh,kl);
  mm=set of char;
  zeile=string[60];

Var
  w1,w2,w3,w4,w5,wmain:byte;
  Taste,maintaste:char;
  rcode:word;                                                     { Tasten-Rckgabecode }
  i, MpktX,MpktY,Mpkt,Mpkttxt,mainpkt:integer;
  tag,monat,jahr,stunde,min,dayofw,sec,sec100:word;
  ltag,lmonat,lstunde,lmin:string[1];
  altstr,lesestr:zeile;
  Verffile,schlfile,progfile:text; { Verzeichnisse }
  Verftext:array[1..20] of Verfahren; { Feld Verfahrensbezeichnungen }
  Schltext,progtext:array[1..20] of dtname; { Feld Schlssel,Programme }
  Akt_Dat:array[datind] of Dtname; { aktuelle Dateien Schl,Prog }
  lw:char;
  verf_Ausw_li:VerfFeld;
  Verf_Ausw_re:VerfFeld;
  Verfbez:verfahren;
  TxTK,TxtG,TxtS:textliste;
  TxTfile:text;
  druckfile:text;
  drucktext:char;
  ktname,gtname:dtname;
  dw,ok:boolean; { Dateinamenwechsel,Verzeichnisse }

Const
  Buausw:set of char=['A'..'T','a'..'t'];
  Farbe:array[1..5] of byte=(2,1,2,1,1);
  eintrag:mm=[' '..'z'];
  Ziffern:mm=[' ', '.', '0'..'9'];
  edzeil:integer=24;
  edspalt:integer=70;
  altd:word=32;
  altc:word=46;

{#########################################################}

procedure verzeichnisse(Var ok:boolean); { VERZEICHNISSE LESEN }

Var
  i:integer;

begin
  assign(verffile,'verf_dat.txt');
  assign(schlfile,'schl_dat.txt');
  assign(progfile,'prog_dat.txt');
  {$I-} reset(verffile); if ioresult=0 then ok:=true else ok:=false;
  reset(schlfile); if ioresult=0 then ok:=ok and true
                                 else ok:=ok and false;
  reset(progfile); if ioresult=0 then ok:=ok and true
                                 else ok:=ok and false; {$I+}
  for i:=1 to 20 do
    begin
      readln(verffile,verftext[i]);
      readln(schlfile,schltext[i]);
      readln(progfile,progtext[i]);
    end;
  close(verffile); close(schlfile); close(progfile);
end;

procedure CRon;                       { CURSOR AN }
begin
  inline($b1/6/$b5/6/$b4/1/$cd/$10);
end;

procedure CRoff;                      { CURSOR AUS }
begin
  inline($b1/8/$b5/8/$b4/1/$cd/$10);
end;

procedure einzeil(var st:zeile; tex:zeile; m:mm; l,ze,sp:integer; var cc:char);

  const s:set of byte=[8,75,77];
  var i:integer;
      ta:string[2];
      c:char;

procedure cure;

begin
  inline($50/$52/$b4/02/$b2/$1b/$cd/$21/$b2/$5b/$cd/$21);
  inline($b2/$31/$cd/$21/$b2/$43/$cd/$21/$5a/$58)
end;

procedure culi;

begin
  inline($50/$52/$b4/02/$b2/$1b/$cd/$21/$b2/$5b/$cd/$21);
  inline($b2/$31/$cd/$21/$b2/$44/$cd/$21/$5a/$58)
end;

begin
  Cron;
  st:='';
  for i:=1 to l do st:=st+' ';
  for i:=1 to length(tex) do st[i]:=tex[i];
  i:=1; gotoxy(ze,sp); write(tex);
  repeat
    gotoxy(ze+i-1,sp);
    c:=readkey; if c<>#27 then begin
    case c in m of
    true:ta:=c;
    false:case ord(c) in s of
          true:ta:=chr(27)+c;
          false:case ord(c) of
                0:begin c:=readkey;
                if ord(c) in s then ta:=chr(27)+c
                else ta:='' end
                else ta:=''
                end;
          end;
  end;
  if ta<>''then
  begin
  if ta[1]<>chr(27) then begin write(c); st[i]:=c;
                               if i<l then i:=i+1 else culi
                         end else
    case ord(ta[2]) of
    8:if i>1 then begin st[i]:=' '; i:=i-1; st[i]:=' ';
                        culi; write(' '); culi; culi
                  end;
    75:if i>1 then begin i:=i-1; culi end;
    77:if i<1 then begin i:=i+1; cure end;
    end;
    end;                              end;
  until ((c=chr(13)) or (c=chr(27))); cc:=c;
  i:=l+1;
  repeat
  i:=i-1
  until (i=0) or (st[i] <> ' ');
  if i<>0 then st:=copy(st,1,i)
  else st:='';
  Croff;
end;

procedure Texthell;                      { TEXT HELL }

begin
  textbackground(black);
  textcolor(lightgray);
end;

procedure Textdunkel;                    { TEXT DUNKEL }

begin
  textbackground(lightgray);
  textcolor(black);
end;

procedure Faerben(i:byte);               { FARBE }

begin
  case i of
    1:texthell;
    2:textdunkel;
  end;
end;

procedure Fensterauf(W:byte);            { FENSTER }

begin
  selwindow(w);
  w:=farbe[w];
  faerben(w);
end;

procedure Lies_Dat;                    { DATUM/ZEIT }

begin
  gotoxy(1,1);
  getdate(jahr,monat,tag,dayofw);
  gettime(stunde,min,sec,sec100);
  if tag<10 then ltag:=' ' else ltag:='';
  if monat<10 then lmonat:='0' else lmonat:='';
  if min<10 then lmin:='0' else lmin:='';
  if stunde<10 then lstunde:=' ' else lstunde:='';
  writeln(' Datum: ',ltag,tag,'.',lmonat,monat,'.',jahr);
  write(' Zeit:  ',lStunde,stunde,'.',lmin,min,' Uhr');
end;

procedure ChangeDatTime;                { DAT/TIME WECHSEL }

Var
  sttag,stmonat,ststunde,stmin:string[2];
  stjahr:string[4];
  code:integer;

begin
  wmain:=screenptr;
  openwindowheader(20,15,42,18,' Dat/Time ndern ');
  clrscr;
  Lies_Dat;
  str(tag,sttag); str(monat,stmonat); str(jahr,stjahr);
  str(stunde,ststunde);str(min,stmin);
  if monat<10 then stmonat:='0'+copy(stmonat,1,1);
  if min<10 then stmin:='0'+copy(stmin,1,1);
  if tag<10 then sttag:=' '+copy(sttag,1,1);
  if stunde<10 then ststunde:=' '+copy(ststunde,1,1);
  altstr:=sttag+'.'+stmonat+'.'+stjahr;
  einzeil(altstr,altstr,ziffern,10,9,1,taste); if taste<>#27 then
  begin
    Val(copy(altstr,1,2),tag,code);
    Val(copy(altstr,4,2),monat,code);
    Val(copy(altstr,7,4),jahr,code);
    altstr:=ststunde+'.'+stmin;
    einzeil(altstr,altstr,ziffern,5,9,2,taste);
    Val(copy(altstr,1,2),stunde,code);
    Val(copy(altstr,4,2),min,code);
    setdate(jahr,monat,tag);
    settime(stunde,min,sec,sec100);
  end;
  fensterauf(w2);
  Lies_dat;
  fensterauf(wmain);
  closewindow;
end;

procedure Zeitfenster;                  { DAT/TIME-FENSTER }

begin
  openwindow(55,3,77,6);
  w2:=screenptr;
  faerben(farbe[w2]);
  clrscr;
  Lies_Dat;
end;

procedure Simkopf;                      { KOPFAUSSCHRIFT }

begin
  openwindow(1,1,80,8);
  w1:=screenptr;
  faerben(farbe[w1]);
  clrscr;
  gotoxy(5,3);
  write('Programmpaket  S I M U L A T I O N E N /1');
  gotoxy(20,4);
  write('Vers 1.0 (12.12.89)');
  zeitfenster;
end;

procedure Schreibausw(Feld:verffeld;x,y:integer);           { AUSWAHLTEXT }

Var
  i:integer;

begin
  for i:=1 to 10 do begin
                      gotoxy(x,y-1+i);
                      write(feld[i]);
                    end;
end;

procedure SimAuswahl;                                       { AUSWAHLFENSTFR }

begin
  openwindow(1,8,80,25);
  w3:=screenptr;
  faerben(farbe[w3]);
  clrscr;
  gotoxy(6,2);
  textcolor(black);
  write('Verfahren:');
  texthell;
  gotoxy(6,16);
  write(' Fl: Help      '); gotoxy(wherex+3,wherey);
  write(' F2: Dat/Time  '); gotoxy(wherex+3,wherey);
  write(' F3: Eintr nd '); gotoxy(wherex+3,wherey);
  write(' ESC: Quit     ');
  openwindow(7,11,30,22);
  w4:=screenptr;
  faerben(farbe[w4]);
  clrscr;
  schreibausw(verf_ausw_li,1,1);
  openwindow(31,11,54,22);
  w5:=screenptr;
  faerben(farbe[w5]);
  clrscr;
  schreibausw(verf_ausw_re,1,1);
end;

{#################################################### HAUPTMEN }

procedure Hauptmenue (Var Menue_PktX, Menue_PktY:integer);

Var
  x,y,breite,spalten,anzbyte,anzahl,punkt:word;
  bool:boolean;
  name:verffeld;

procedure ChangeEintrag;                               { EINTRAG NDERN }

begin
  altstr:=name[punkt];
  lesestr:=altstr;
  openwindowheader(20,15,43,17,' Eintrag ndern ');
  einzeil(lesestr,lesestr,eintrag,21,1,1,taste);
  if wmain=4 then verf_ausw_li[punkt]:=copy(altstr,1,4)+copy(lesestr,5,16)+' '
             else verf_ausw_re[punkt]:=copy(altstr,1,4)+copy(lesestr,5,16)+' ';
  name[punkt]:=copy(altstr,1,4)+copy(lesestr,5,16)+' ';
  if LetztesZeichen = #27 then name[punkt]:=altstr;
  closewindow;
end;

begin                                                 { START HAUPTMENU }
  Simkopf;
  Simauswahl;
  punkt:=menue_pkty;
  if Menue_pktx=1 then begin
                         fensterauf(w4);
                         x:=1;
                         name:=verf_ausw_li;
                       end
                  else begin
                         fensterauf(w5);
                         x:=1;
                         name:=verf_ausw_re;
                       end;
  y:=1;
  breite:=21;spalten:=1;anzahl:=10;bool:=true;
  repeat
    Auswahl(x,y,breite,spalten,sizeof(name[punkt]),name,anzahl,punkt,bool);
    taste:=readkey;
    case taste of
      #0:begin
           taste:=readkey;
           case taste of
             #59:begin
                  assign(helpfile,'Simausw.hlp');
                  hilfe('#hilfef1');
                 end;
             #60:begin
                   maintaste:=taste;
                   wmain:=screenptr;
                   ChangedatTime;
                   fensterauf(wmain);
                   taste:=maintaste;
                 end;
             #61:begin
                   maintaste:=taste;
                   wmain:=screenptr;
                   changeeintrag;
                   fensterauf(wmain);
                   taste:=maintaste;
                 end;
             #72:begin
                   if punkt>1 then punkt:=punkt-1
                              else punkt:=10;
                 end;
             #80:begin
                   if punkt<10 then punkt:=punkt+1
                               else punkt:=1;
                  end;
             #75:begin
                    x:=1;
                    name:=verf_ausw_li;
                    schreibausw(verf_ausw_re,1,1);
                    fensterauf(w4);
                 end;
             #77:begin
                    x:=1;
                    name:=verf_ausw_re;
                    schreibausw(verf_ausw_li,1,1);
                    fensterauf(w5);
                 end;
             end;
           end;
           'A'..'J','a'..'j':begin
                               punkt:=(ord(taste) and 15);
                               x:=1;
                               taste:=#13;
                               fensterauf(w4);
                            end;
          'K'..'T','k'..'t':begin
                               punkt:=(ord(taste) and 31)-10;
                               x:=1;
                               taste:=#13;
                               fensterauf(w5);
                            end;
  end;
  until((taste=#13) or (taste=#27));
  if screenptr=w4 then menue_pktx:=1
                  else menue_pktx:=2;
  menue_pkty:=punkt;
  while maxscreen>0 do closewindow;
end;

{************************************************* ENDE HAUPTMEN }

procedure Akt_lw(var lw:char);                   { LAUFWERK }

Var
  regs:registers;
  lwby:byte;

begin
  regs.ah:=$19;
  intr($21,regs);
  lwby:=regs.al;
  lw:=chr(65+lwby);
end;

procedure Copyyerf;                              { EINTR4GE LESEN }

Var
  i:integer;

begin
  for i:=1 to 10 do verf_ausw_li[i]:=verftext[i];
  for i:=11 to 20 do verf_ausw_re[i-10]:=verftext[i];
end;

procedure Recopy_verf;                           { EINTRAGE SCHREIBEN }

Var
  i:integer;

begin
  for i:=1 to 10 do Verftext[i]:=verf_ausw_li[i];
  for i:=11 to 20 do Verftext[i]:=verf_ausw_re[i-10];
end;

{################################################ MEN FUNKTIONEN   }

procedure Menue_fkt(Var Menue_Pkt:integer);

Type
  Auswzeile=string[18];

Var
  wf1,wf2,wf3,wf4:integer;
  i,j:integer;
  x,y:integer;
  wahl:word;
  code:boolean;

Const
  Wahlbu:set of char=['C','D','S','T', 'Z','c' ,'d','s','t','z'];
  Ftext:array[1..5] of Auswzeile=(' Texte           ',
                                  ' Schlssel        ',
                                  ' Dechiffrieren    ',
                                  ' Chiffrieren      ',
                                  ' Zusatzfunktionen ');

begin
  openwindow(1,1,80,5);
  wf1:=screenptr;
  textdunkel;
  clrscr;
  gotoxy(5,2);
  write('VERFAHREN ',Akt_dat[vf]);
  openwindow(1,21,80,25);
  wf2:=screenptr;
  textdunkel;
  clrscr;
  texthell;
  gotoxy(5,2);
  write('F1: Help');
  gotoxy(wherex+55,wherey);
  write('ESC: Quit');
  openwindow(1,6,80,20);
  wf3:=screenptr;
  textbackground(green);
  clrscr;
  openwindow(10,10,30,16);
  wf4:=screenptr;
  texthell;
  clrscr;
  x:=1;y:=1;
  wahl:=menue_pkt;code:=true;
  repeat
    Auswahl(x,y,18,1,sizeof(ftext[wahl]),ftext,5,wahl,code);
    if rcode<>0 then taste:=#13 else
    taste:=readkey;
    case taste of
      'C','c':begin wahl:=4;
                    taste:=#13;
              end;
      'D','d':begin wahl:=3;
                    taste:=#13;
              end;
      'S','s':begin wahl:=2;
                    taste:=#13;
              end;
      'T','t':begin wahl:=1;
                    taste:=#13;
              end;
      'Z','z':begin wahl:=5;
                    taste:=#13;
              end;
      #0:begin taste:=readkey;
           case taste of
             #72:if wahl>1 then wahl:=wahl-1
                           else wahl:=5;
             #80:if wahl<5 then wahl:=wahl+1
                           else wahl:=1;
             #59:begin
                   assign(helpfile,'Simfkt.hlp');
                   hilfe('#hilfef1');
                 end;
           end;
         end;
    end;
  until ((taste=#13) or (taste=#27));
  menue_pkt:=wahl;
  while maxscreen>0 do closewindow;
end;

procedure ChangeDatei(Var Name:dtname);                 { DATEINAMENWECHSEL }

Var
  altstring:zeile;
  zeichen:set of char;
  vglstring:dtname;
  Pospkt:byte;

begin
  altstring:='';
  vglstring:=name;
  zeichen:=eintrag+ziffern;
  openwindowheader(6,10,70,12,' Change Dt-Name ');
  altstring:=copy(altstring,1,0)+name;
  einzeil(altstring,altstring,zeichen,60,1,1,taste);
  name:=altstring;
  { pospkt:=pos(',',name);
   if ((pospkt=0) and (name<>'')) then name:=name+',txt'; }
   if name=vglstring then dw:=false else dw:=true;
  closewindow;
end;

{################################################ DATEIVERARBEITUNG }

procedure Aufruf_Editor(name:dtname;Var txt:textliste);    { EDITOR }

var
  x,y,z:word;
  c:char;

begin
  if name='' then begin
                     openwindow(20,10,60,13);
                     texthell; clrscr;
                     write(' Dateiname leer !');
                     taste:=readkey;
                     closewindow;
                   end
  else begin
         openwindow(1,1,80,25);
         clrscr;
         cron;
         if dw=true then neuertext(txt);
         x:=1;y:=1;z:=1;clrscr;
         edittext(txt,x,y,z,79,23,true);
         croff;
         closewindow;
      end;
      taste:=#0;
end;

procedure Disk_Lesen(Name:dtname;Var txt:textliste);        { DATEI LESEN }

Var
  code:integer;

begin
  assign(txtfile,name);
  {$I-} reset(txtfile);{$I+}
  code:=ioresult;
  if name='' then code:=2;
  case code of
    0:begin close(txtfile);
            openwindow(18,10,58,13);
            textdunkel;clrscr;
            write(' Datei wird gelesen !');
            Liestext(txtfile,txt);
            closewindow;
      end;
    2,3:begin openwindow(18,10,58,13);
              write(' Datei/Suchweg nicht gefunden !');
              taste:=readkey;taste:=#0;
              closewindow;
       end;
  end;
  taste:=#0;
end;

procedure Disk_Schreiben(name:dtname;Var txt:textliste);    { DATEI SCNREIBEN }

Var
  code:integer;

begin
  assign(txtfile,name);
  {$I-} reset(txtfile);{$I+}
  code:=ioresult;
  if name='' then begin
                    openwindow(20,10,60,13);
                    texthell;clrscr;
                    write(' Dateiname leer ! ');
                    taste:=readkey;
                    closewindow;
                    code:=3;
                  end;
  if code=0 then
    begin openwindow(14,10,61,13);
          write(' Datei ',name,' berschreiben ? J/N ');
          repeat
            taste:=readkey;
            taste:=upcase(taste);
          until taste in ['J','N'];
          write(taste);
          closewindow;
    end;
  if code=2 then taste:='J';
            if taste='J' then begin openwindow(20,10,60,13);
                                    textdunkel;clrscr;
                                    write(' Datei wird geschrieben ! ');
                                    schreibtext(txtfile,txt);
                                    closewindow;
                              end;
  taste:=#0;
end;

procedure Datei_drucken(name:dtname);                       { DATEI DRUCKEN }

Var i:integer;

begin
  if name='' then begin
                    openwindow(20,10,60,13);
                    texthell;clrscr;
                    write(' Dateiname leer !');
                    taste:=readkey;
                    closewindow;
                  end
  else begin
         openwindow(14,10,61,13);
         textdunkel;
         clrscr;
         write(' Datei ',name,' wird gedruckt !');
         assign(druckfile,name);
         {$I-} reset(druckfile);{$I+}
         if ioresult=0 then begin
                              repeat
                                read(druckfile,drucktext);
                                write(lst,drucktext);
                              until drucktext=^Z;
                            end;
         write(lst,#12);
         close(druckfile);
         closewindow;
       end;
  taste:=#0;
end;

procedure Edit(Dateiname:zeile);                            { DATEIVERARBEITUNG
                                                             Hauptprogramm }
Var
  x,y,breite,wpkt:word;

Const
   Editausw:array[1..4] of string[20]=(' Editieren          ',
                                      ' Lesen von Disk     ',
                                      ' Speichern auf Disk ',
                                      ' Drucken            ');

begin
  dw:=false;
  case mpkttxt of
    1:openwindowheader(10,8,65,21,' KLARTEXT ');
    2:openwindowheader(10,8,65,21,' GEHEINTEXT ');
    3:openwindowheader(10,8,65,21,' SCHLSSEL ');
  end;
  wpkt:=1;
  repeat
    textbackground(green);
    textcolor(white);
    clrscr;
    gotoxy(4,2);
    case mpkttxt of
      1:write(' Datei: ',akt_dat[kl]);
      2:write(' Datei: ',akt_dat[gh]);
      3:write(' Datei: ',akt_dat[sl]);
    end;
    texthell;
    x:=7;y:=5;breite:=20;
    Auswahl(x,y,breite,1,sizeof(editausw[wpkt]),editausw,4,wpkt,true);
    taste:=readkey;
    case taste of
      #0:begin taste:=readkey;
           case taste of
             #32:begin rcode:=altd;taste:=#27; end;
             #46:begin rcode:=altc;taste:=#27; end;
             #72:if wpkt>1 then wpkt:=wpkt-1 else wpkt:=4;
             #80:if wpkt<4 then wpkt:=wpkt+1 else wpkt:=1;
             #60:begin
                   case mpkttxt of
                     1:begin changedatei(akt_dat[kl]);
                       if dw=true then neuertext(txtk);
                       dw:=false;
                     end;
                     2:begin changedatei(akt_dat[gh]);
                       if dw=true then neuertext(txtg);
                       dw:=false;
                     end;
                     3:begin changedatei(akt_dat[sl]);
                       if dw=true then neuertext(txts);
                       dw:=false;
                     end;
                 end;
               taste:=#0;
               end;
         end;
     end;
    'E','e':begin wpkt:=1; case mpkttxt of
                             1:Aufruf_Editor(akt_dat[kl],txtk);
                             2:Aufruf_Editor(akt_dat[gh],txtg);
                             3:Aufruf_Editor(akt_dat[sl],txts);
                           end;
            end;
    'L','l':begin wpkt:=2;case mpkttxt of
                            1:Disk_lesen(akt_dat[kl],txtk);
                            2:Disk_lesen(akt_dat[gh],txtg);
                            3:Disk_lesen(akt_dat[sl],txts);
                          end;
            end;
    'S','s':begin wpkt:=3;case mpkttxt of
                            1:Disk_schreiben(akt_dat[kl],txtk);
                            2:Disk_schreiben(akt_dat[gh],txtg);
                            3:Disk_schreiben(akt_dat[sl],txts);
                          end;
            end;
    'D','d':begin wpkt:=4;case mpkttxt of
                            1:Datei_drucken(akt_dat[kl]);
                            2:Datei_drucken(akt_dat[gh]);
                            3:Datei_drucken(akt_dat[sl]);
                          end;
            end;
    #13:case wpkt of
          1:begin case mpkttxt of
                    1:Aufruf_Editor(akt_dat[kl],txtk);
                    2:Aufruf_Editor(akt_dat[gh],txtg);
                    3:Aufruf_Editor(akt_dat[sl],txts);
                  end;
            end;
          2:begin case mpkttxt of
                    1:Disk_lesen(akt_dat[kl],txtk);
                    2:Disk_lesen(akt_dat[gh],txtg);
                    3:Disk_lesen(akt_dat[sl],txts);
                  end;
            end;
          3:begin case mpkttxt of
                    1:Disk_schreiben(akt_dat[kl],txtk);
                    2:Disk_schreiben(akt_dat[gh],txtg);
                    3:Disk_schreiben(akt_dat[sl],txts);
                  end;
            end;
          4:begin wpkt:=4;case mpkttxt of
                            1:Datei_drucken(akt_dat[kl]);
                            2:Datei_drucken(akt_dat[gh]);
                            7:datei_drucken(akt_dat[sl]);
                          end;
            end;
       end;
     end;
  until taste=#27;taste:=#0;
  while maxscreen>0 do closewindow;
end;

{####################################################### AUSWAHL TEXTART }

procedure Menue_Texte(Var Menue_Pkt:integer);

Type
  Auswzeile=string[43];

Var
  wf1,wf2,wf3,wf4:integer;
  i,j:integer;
  x,y:integer;
  wahl:word; 
  code:boolean;

Const
  Wahlbu:set of char=['G','K','g','k'];
  Auswtext:array[1..2] of
     auswzeile=('Klartext bearbeiten   ',
                'Geheimtext bearbeiten ');

begin
  if ((rcode=altd) or (rcode=altc)) then
  else
    begin
    openwindow(1,1,80,5);
    wf1:=screenptr;
    textdunkel;
    clrscr;
    gotoxy(5,2);
    write('TEXTE ',Akt_dat[vf]);
    openwindow(1,21,80,25);
    wf2:=screenptr;
    textdunkel;
    clrscr;
    texthell;
    gotoxy(5,2);
    write('F1: Help');
    gotoxy(wherex+10,wherey);
    write('F2: Datei ');
    gotoxy(wherex+35,wherey);
    write('ESC: Quit');
    openwindow(1,6,80,20);
    wf3:=screenptr;
    textbackground(green);
    clrscr;
    openwindow(10,10,55,13);
    wf4:=screenptr;
    texthell;
    clrscr;
    x:=1;y:=1;
    wahl:=menue_pkt;code:=true;
    repeat
      Auswahl(x,y,43,1,sizeof(auswtext[wahl]),auswtext,2,wahl,code);
      taste:=readkey;
      case taste of
        'K','k':begin wahl:=1;
                     taste:=#13;
                end;
        'G','g':begin wahl:=2;
                      taste:=#13;
                end;
        #0:begin taste:=readkey;
           case taste of
             #32:begin rcode:=altd;taste:=#27; end;
             #46:begin rcode:=altc;taste:=#27; end;
             #72:if wahl=2 then wahl:=1 else wahl:=2;
             #80:if wahl=1 then wahl:=2 else wahl:=1;
             #59:begin
                   assign(helpfile,'simtxt.hlp');
                   hilfe('#hilfef1');
                end;
             #64:begin
                   if wahl=1 then changedatei(akt_dat[kl])
                             else changedatei(akt_dat[gh]);
                   taste:=#0;
                 end;
           end;
        end;
     end;
    until ((taste=#13) or (taste=#27));
    menue_pkt:=wahl;
  end; {else }
end;

procedure Menue_Schl;                                       { MEN SCHLSSEL }

Var
  wf1,wf2,wf3:integer;

begin
  openwindow(1,1,80,5);
  wf1:=screenptr;
  textdunkel;
  clrscr;
  gotoxy(5,2);
  write('SCHLSSEL ',Akt_dat[sl]);
  openwindow(1,21,80,25);
  wf2:=screenptr;
  textdunkel;
  clrscr;
  texthell;
  gotoxy(5,2);
  write('F1: Help');
  gotoxy(wherex+10,wherey);
  write('F2: Datei');
  gotoxy(wherex+35,wherey);
  write('ESC: Quit');
  openwindow(1,6,80,20);
  wf3:=screenptr;
  textbackground(green);
  clrscr;
end;

{######################################################## FUNKTIONEN CHIFF/DECH }

procedure Fkt_DC(Art:char);

Var
  kdostring,verfname:string;

begin
  openwindow(1,1,80,5);
  textdunkel;
  clrscr;
  gotoxy(5,2);
  case art of
    'c':write(' CHIFFRIEREN - ');
    'd':write(' DECHIFFRIEREN - ');
  end;
  write(verfbez);
  openwindow(1,21,80,25);
  textdunkel;
  clrscr;
  texthell;
  gotoxy(5,2);
  write('Abbruch: CTRL PAUSE');
  gotoxy(63,2);
  write('Taste: Quit');
  openwindow(1,6,80,20);
  textbackground(green);
  clrscr;
  textcolor(white);
  gotoxy(10,2);
  writeln('Geheimtext: ',akt_dat[gh]);
  gotoxy(10,wherey);
  writeln('Klartext:   ',akt_dat[kl]);
  gotoxy(1,5);
  case art of
    'd':openwindowheader(1,11,80,20,' Klartext   ');
    'c':openwindowheader(1,11,80,20,' Geheimtext ');
  end;
  texthell;clrscr;
  verfname:=copy(akt_dat[vf],1,6);
  kdostring:=verfname+' '+akt_dat[sl]+' '+akt_dat[gh]+' '+akt_dat[kl];
  case art of
    'd':kdostring:='d '+kdostring;
    'c':kdostring:='c '+kdostring;
  end;
  case art of
    'd':exec(akt_dat[pr],kdostring);
    'c':exec(akt_dat[pr],kdostring);
  end;
  taste:=readkey;
  case art of
    'd':begin
          neuertext(txtk);
          Disk_lesen(akt_dat[kl],txtk);
          Aufruf_Editor(akt_dat[kl],txtk);
        end;
    'c':begin
          neuertext(txtg);
          Disk_lesen(akt_dat[gh],txtg);
          Aufruf_Editor(akt_dat[gh],txtg);
        end;
    end;
    taste:=#27;
  while maxscreen>0 do closewindow;
end;

{************************************************************* HAUPTPROGRAMM
****************************************************************************}

begin
  clrscr;
  akt_lw(lw);
  neuertext(txts);
  neuertext(txtk);
  neuertext(txtg);
  verzeichnisse(ok);
  if ok=false then begin
                     openwindow(15,8,55,12);
                     write(' Dateifehler Verzeichnisse !');
                     closewindow;
                   end;
  recopy_verf;
  Akt_Dat[gh]:='';Akt_Dat[kl]:='';Akt_Dat[sl]:='';
  croff;
  mpktx:=1;mpkty:=1;rcode:=0;
  repeat
    hauptmenue(mpktx,mpkty);
    if taste<>#27 then
    begin
      maintaste:=taste;
      if mpktx=1 then verfbez:=copy(verf_ausw_li[mpkty],5,16)
                 else verfbez:=copy(verf_ausw_re[mpkty],5,16);
      akt_dat[vf]:=verfbez;
      akt_dat[sl]:=schltext[(mpktx-1)*10+mpkty];
      akt_dat[pr]:=progtext[(mpktx-1)*10+mpkty];
      if akt_dat[sl]<>'' then begin
                                assign(txtfile,akt_dat[sl]);
                                {$I-} reset(txtfile); {$I+}
                                if ioresult=0 then liestext(txtfile,txts);
                              end;
    mpkt:=1;
    repeat
      if rcode<>0 then begin
                         case rcode of
                           32:mpkt:=3;
                           46:mpkt:=4;
                         end;
                         taste:=#0;
                       end;
      menue_fkt(mpkt);
      if taste<>#27 then
        case mpkt of
          1:begin
            mpkttxt:=1;
            repeat
              menue_texte(mpkttxt);
              if taste<>#27 then
                case mpkttxt of
                  1:edit(akt_dat[kl]);
                  2:edit(akt_dat[gh]);
                end;
              if rcode<>0 then taste:=#27;
              until taste=#27;
              taste:=#0;
            end;
          2:begin mainpkt:=mpkttxt;                        { Schlsselbereitstellung }
                  menue_schl;
                  mpkttxt:=3;
                  edit(akt_dat[sl]);
                  mpkttxt:=mainpkt;
                  taste:=#0;
            end;
          3:begin fkt_dc('d'); taste:=#0; rcode:=0; end;    { Dechiffrieren }
          4:begin fkt_dc('c'); taste:=#0; rcode:=0; end;    { Chiffrieren }
          5:begin end;                                      { Zusatzfunktionen }
       end;
       until taste=#27; taste:=maintaste;
    end;
    until taste=#27;
    recopy_verf;
    rewrite(verffile);
    for i:=0 to 20 do writeln(verffile, verftext[i]);
    close(verffile);
    cron;
end.